import jp.jig.jiglet.*;

public class clkseg2 extends Jiglet {
	boolean display = true;
	int worlddt = 8;
	public void main() {
		setMenu(new String[] { "wv", "(c)taisuke" }, new String[] { "wv\܂", "taisuke's jiglet̃TCgɃANZX܂" });
		setSoftLabel("I");
		long deactivetime = 0;
		final int VIEWTIME = 3 * 60 * 1000;
		
		if (load()) {
			help();
		}
		for (;;) {
			int key = getKey();
			if (key == KEY_SOFT || key == KEY_IAPP) {
				terminate();
			} else if (key > KEY_LAST) {
				int evt = key & 0xffff0000;
				int val = key & 0xffff;
				if (evt == EVENT_MENU) {
					if (val == 0) {
						help();
					} else if (val == 1) {
						launch("http://club.jig.jp/taisuke/", ENCODE_SJIS, LAUNCH_KEEP_ALIVE);
					}
				} else if (evt == EVENT_CLOSE) {
					display = false;
				} else if (evt == EVENT_OPEN) {
					display = true;
					deactivetime = 0;
				} else if (evt == EVENT_ACTIVATE) {
					terminate();
				}
			}
			if (key == KEY_RIGHT) {
				if (worlddt == 23)
					worlddt = 0;
				else
					worlddt++;
				save();
			} else if (key == KEY_LEFT) {
				if (worlddt == 0)
					worlddt = 23;
				else
					worlddt--;
				save();
			}
			if (getState(STATE_JIGLET) == JIGLET_DEACTIVE) {
				if (deactivetime == 0)
					deactivetime = currentTime();
				if (currentTime() - deactivetime > VIEWTIME)
					display = false;
			}
			repaint();
			sleep(10);
			
			if (!display) {
				setState(STATE_JIGLET, JIGLET_SLEEP);
			}
		}
	}
	void help() {
		showDialog("オEvŁAgѓdbɐݒ肳ꂽvłBEv͍Eł炷Ƃł܂BႦ΃AJC݂̉ĎԂ́A{-16ԂłB", DIALOG_TYPE_OK);
	}
	int fw, fh;
	int sx, sy;
	int sw, sh;
	int margin;
	public void paint(boolean allDrawFlag) {
		// for init
		setFont(FONT_SMALL);
		if (fw == 0) {
			fw = stringWidth("");
			fh = getFontHeight();
		}
		// for clock
		setTime(currentTime());
		int hour = getTime(CALENDAR_HOUR_OF_DAY);
		int min = getTime(CALENDAR_MINUTE);
		int sec = getTime(CALENDAR_SECOND);
		//----------------------------------------
		
		setColor(0x000000);
		fillRect(0, 0, DW, DH);
//		Image bg = getConciergeImage();
//		drawImage(bg, (DW - bg.getWidth()) / 2, (DH - bg.getHeight()) / 2);
		
		if (!display)
			return;
		
		int hour2 = hour + worlddt;
		if (hour2 < 0)
			hour2 += 24;
		else if (hour2 > 23)
			hour2 -= 24;
		
		int ox = DW / 2;
		int oy = DH / 2;
		drawArcClock(ox, oy, DW < DH ? DW : DH, hour2, min, sec);
		
		int[] value = new int[6];
		value[0] = hour / 10;
		value[1] = hour % 10;
		value[2] = min / 10;
		value[3] = min % 10;
		value[4] = sec / 10;
		value[5] = sec % 10;
		
		draw7segClock(0, 0, value);
		
		value[0] = hour2 / 10;
		value[1] = hour2 % 10;
		draw7segClock(0, 1, value);
	}
	void drawArcClock(int ox, int oy, int maxr, int hour, int min, int sec) {
		int div = 7;
		int step = 5;
		int r, th;
		
		setColor(0x444444);
		r = maxr * step-- / div / 2;
		th = 90 - sec * 360 / 60;
		drawNeedle(ox - r, oy - r, r * 2, r * 2, th);
		
		setColor(0x888888);
		r = maxr * step-- / div / 2;
		th = 90 - (min * 360 + sec * 6) / 60;
		drawNeedle(ox - r, oy - r, r * 2, r * 2, th);
		
		setColor(0xbbbbbb);
		r = maxr * step-- / div / 2;
		th = 90 - (hour % 12 * 360 + min * 6 + sec / 10) / 12;
		drawNeedle(ox - r, oy - r, r * 2, r * 2, th);
	}
	void drawNeedle(int x, int y, int w, int h, int th) {
		int dth = 10;
		fillArc(x, y, w, h, th + dth / 2, 360 - dth);
	}
	void draw7segClock(int ox, int oy, int[] value) {
		int mg = 2; // 
		int tw = DW / 50; // 
		int dotw = tw + mg * 2; // hbg̑傫
		int dw = (DW - dotw * 2) / 8; // ̕
		int dh = dw; // * 2; // ̍
		int offx = DW / 8 + mg + ox;
		int offy = (DH - (dh + mg * 5 + tw) * oy) / 4 * 3;
		
		int x = offx;
		int y = offy;
		for (int i = 0; i < 6; i++) {
			setColor(0xffffff);
			draw7segColor(value[i], x, y, dw - mg * 2, dh - mg * 2, tw);
			x += dw;
			if (i == 1 || i == 3) {
				if (value[5] % 2 == 0) {
					setColor(0xffffff);
					draw1seg(x, y + (dh - dotw) / 6, tw, tw);
					draw1seg(x, y + (dh - dotw) * 5 / 6, tw, tw);
				}
				x += tw + mg * 2;
			}
		}
	}
	//------------------------------------------------------------------
	// n >= 0, n <= 9
	static int[] SEG7 = {
		125,
		96,
		55,
		103,
		106,
		79,
		95,
		105,
		127,
		111,
	};
	static int segbgcolor = 0x777777;
	static int segcolor = 0xffffff;
	static int mgseg = 1;
	static void draw7segColor(int n, int x, int y, int w, int h, int tw) {
		setColor(segbgcolor);
		draw7seg(n, x, y, w, h, tw);
		setColor(segcolor);
		draw7seg(n, x, y, w, h, tw - mgseg);
//		draw7seg(n, x + mgseg, y + mgseg, w - mgseg * 2, h - mgseg * 2, tw);
	}
	static void draw7seg(int n, int x, int y, int w, int h, int tw) {
		int d = SEG7[n];
		if ((d & (1 << 0)) != 0) { // 
			fillRect(x, y, w, tw);
		}
		if ((d & (1 << 1)) != 0) { // 
			fillRect(x, y + (h - tw) / 2, w, tw);
		}
		if ((d & (1 << 2)) != 0) { // 
			fillRect(x, y + (h - tw), w, tw);
		}
		if ((d & (1 << 3)) != 0) { // 
			fillRect(x, y, tw, h / 2);
		}
		if ((d & (1 << 4)) != 0) { // 
			fillRect(x, y + h / 2, tw, h / 2);
		}
		if ((d & (1 << 5)) != 0) { // E
			fillRect(x + (w - tw), y, tw, h / 2);
		}
		if ((d & (1 << 6)) != 0) { // E
			fillRect(x + (w - tw), y + h / 2, tw, h / 2);
		}
	}
	static void draw1seg(int x, int y, int w, int h) {
		setColor(segbgcolor);
		fillRect(x, y, w, h);
		setColor(segcolor);
		fillRect(x + mgseg, y + mgseg, w - mgseg * 2, h - mgseg * 2);
	}
	//------------------------------------------------------------------
	boolean load() { // init true
		byte[] b = readSP(0, 1);
		if (b[0] == 0) {
			worlddt = -16;
			return true;
		} else {
			worlddt = b[0];
			return false;
		}
	}
	void save() {
		writeSP(0, new byte[] { (byte)(worlddt + 1) });
	}
}
